﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.UltraChart.Core.Primitives;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Core.Layers;
using Infragistics.UltraChart.Resources;
using Infragistics.UltraChart.Core;

namespace WC_BoxRotation
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraChart1.ChartType = Infragistics.UltraChart.Shared.Styles.ChartType.BoxChart;

            ultraChart1.BoxChart.BoxWidthFactor = 0.5;
            DataTable dt = new DataTable();

            ultraChart1.Axis.Y.Visible = false;
            ultraChart1.Axis.Y.Labels.Visible = false;
            ultraChart1.Axis.Y2.Visible = true;
            ultraChart1.Axis.Y2.Labels.Visible = true;

            dt.Columns.Add("RowLabel", typeof(string));
            dt.Columns.Add("Minimum", typeof(int));
            dt.Columns.Add("Q1", typeof(int));
            dt.Columns.Add("Q2", typeof(int));
            dt.Columns.Add("Q3", typeof(int));
            dt.Columns.Add("Maximum", typeof(int));

            dt.Rows.Add(new object[] { "Box1", 10, 15, 18, 20, 24});
            dt.Rows.Add(new object[] { "Box2", 12, 18, 19, 20, 21 });
            dt.Rows.Add(new object[] { "Box3", 5, 10, 16, 20, 22 });

            ultraChart1.Axis.Y2.RangeType = Infragistics.UltraChart.Shared.Styles.AxisRangeType.Custom;

            ultraChart1.Axis.Y2.RangeMin = 0;
            ultraChart1.Axis.Y2.RangeMax = 30;
            ultraChart1.Axis.Y2.Labels.Orientation = TextOrientation.Custom;
            ultraChart1.Axis.Y2.Labels.OrientationAngle = 90;

            ultraChart1.Axis.Y.RangeType = Infragistics.UltraChart.Shared.Styles.AxisRangeType.Custom;

            ultraChart1.Axis.Y.RangeMin = 0;
            ultraChart1.Axis.Y.RangeMax = 30;

            ultraChart1.DataSource = dt;
            ultraChart1.Data.DataBind();

        }

        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {
            GraphicsContext gc = e.SceneGraph.OfType<GraphicsContext>().FirstOrDefault();

            if (gc != null)
            {
                gc.Transform = new System.Drawing.Drawing2D.Matrix();
                gc.Transform.Rotate(90);
                gc.Transform.Translate(0, -ultraChart1.Height);
            }

            var boxes = e.SceneGraph.OfType<Box>().Where(b => b.Row >= 0 && b.Column >= 0).ToList();

            foreach (var box in boxes)
            {
                box.Caps = PCaps.None;
            }
        }


    }
}
